package sun.awt;

import java.awt.dnd.peer.DragSourceContextPeer;
import java.awt.dnd.DragSourceContext;
import java.awt.geom.Point2D;
import java.awt.Dimension;
import java.awt.AWTException;
import java.awt.TrayIcon;
import java.util.ResourceBundle;
import java.awt.SystemTray;
import java.awt.MenuShortcut;
import java.awt.MenuItem;
import java.awt.peer.MenuComponentPeer;
import java.awt.MenuContainer;
import java.awt.MenuBar;
import java.util.Vector;
import java.awt.Menu;
import java.awt.event.InvocationEvent;
import java.io.File;
import java.lang.reflect.InvocationTargetException;
import java.awt.event.KeyEvent;
import java.awt.DefaultKeyboardFocusManager;
import java.awt.Font;
import java.awt.Color;
import java.awt.peer.ComponentPeer;
import java.awt.Cursor;
import java.awt.Point;
import java.awt.GraphicsConfiguration;
import java.awt.Shape;
import java.awt.Rectangle;
import java.awt.CheckboxMenuItem;
import java.security.AccessControlContext;
import javax.accessibility.AccessibleContext;
import java.awt.SystemColor;
import java.awt.Toolkit;
import java.awt.ScrollPaneAdjustable;
import java.awt.FileDialog;
import java.awt.PopupMenu;
import java.awt.EventQueue;
import java.awt.MenuComponent;
import java.awt.KeyboardFocusManager;
import java.awt.Frame;
import java.awt.event.MouseEvent;
import java.awt.event.InputEvent;
import java.awt.AWTEvent;
import java.awt.Window;
import java.awt.Container;
import java.awt.Component;
import sun.misc.Unsafe;

public final class AWTAccessor
{
    private static final Unsafe unsafe;
    private static AWTAccessor.ComponentAccessor componentAccessor;
    private static AWTAccessor.ContainerAccessor containerAccessor;
    private static AWTAccessor.WindowAccessor windowAccessor;
    private static AWTAccessor.AWTEventAccessor awtEventAccessor;
    private static AWTAccessor.InputEventAccessor inputEventAccessor;
    private static AWTAccessor.MouseEventAccessor mouseEventAccessor;
    private static AWTAccessor.FrameAccessor frameAccessor;
    private static AWTAccessor.KeyboardFocusManagerAccessor kfmAccessor;
    private static AWTAccessor.MenuComponentAccessor menuComponentAccessor;
    private static AWTAccessor.EventQueueAccessor eventQueueAccessor;
    private static AWTAccessor.PopupMenuAccessor popupMenuAccessor;
    private static AWTAccessor.FileDialogAccessor fileDialogAccessor;
    private static AWTAccessor.ScrollPaneAdjustableAccessor scrollPaneAdjustableAccessor;
    private static AWTAccessor.CheckboxMenuItemAccessor checkboxMenuItemAccessor;
    private static AWTAccessor.CursorAccessor cursorAccessor;
    private static AWTAccessor.MenuBarAccessor menuBarAccessor;
    private static AWTAccessor.MenuItemAccessor menuItemAccessor;
    private static AWTAccessor.MenuAccessor menuAccessor;
    private static AWTAccessor.KeyEventAccessor keyEventAccessor;
    private static AWTAccessor.ClientPropertyKeyAccessor clientPropertyKeyAccessor;
    private static AWTAccessor.SystemTrayAccessor systemTrayAccessor;
    private static AWTAccessor.TrayIconAccessor trayIconAccessor;
    private static AWTAccessor.DefaultKeyboardFocusManagerAccessor defaultKeyboardFocusManagerAccessor;
    private static AWTAccessor.SequencedEventAccessor sequencedEventAccessor;
    private static AWTAccessor.ToolkitAccessor toolkitAccessor;
    private static AWTAccessor.InvocationEventAccessor invocationEventAccessor;
    private static AWTAccessor.SystemColorAccessor systemColorAccessor;
    private static AWTAccessor.AccessibleContextAccessor accessibleContextAccessor;
    
    private AWTAccessor() {
    }
    
    public static void setComponentAccessor(AWTAccessor.ComponentAccessor componentAccessor) {
        AWTAccessor.componentAccessor = componentAccessor;
    }
    
    public static AWTAccessor.ComponentAccessor getComponentAccessor() {
        if (AWTAccessor.componentAccessor == null) {
            AWTAccessor.unsafe.ensureClassInitialized(Component.class);
        }
        return AWTAccessor.componentAccessor;
    }
    
    public static void setContainerAccessor(AWTAccessor.ContainerAccessor containerAccessor) {
        AWTAccessor.containerAccessor = containerAccessor;
    }
    
    public static AWTAccessor.ContainerAccessor getContainerAccessor() {
        if (AWTAccessor.containerAccessor == null) {
            AWTAccessor.unsafe.ensureClassInitialized(Container.class);
        }
        return AWTAccessor.containerAccessor;
    }
    
    public static void setWindowAccessor(AWTAccessor.WindowAccessor windowAccessor) {
        AWTAccessor.windowAccessor = windowAccessor;
    }
    
    public static AWTAccessor.WindowAccessor getWindowAccessor() {
        if (AWTAccessor.windowAccessor == null) {
            AWTAccessor.unsafe.ensureClassInitialized(Window.class);
        }
        return AWTAccessor.windowAccessor;
    }
    
    public static void setAWTEventAccessor(AWTAccessor.AWTEventAccessor awtEventAccessor) {
        AWTAccessor.awtEventAccessor = awtEventAccessor;
    }
    
    public static AWTAccessor.AWTEventAccessor getAWTEventAccessor() {
        if (AWTAccessor.awtEventAccessor == null) {
            AWTAccessor.unsafe.ensureClassInitialized(AWTEvent.class);
        }
        return AWTAccessor.awtEventAccessor;
    }
    
    public static void setInputEventAccessor(AWTAccessor.InputEventAccessor inputEventAccessor) {
        AWTAccessor.inputEventAccessor = inputEventAccessor;
    }
    
    public static AWTAccessor.InputEventAccessor getInputEventAccessor() {
        if (AWTAccessor.inputEventAccessor == null) {
            AWTAccessor.unsafe.ensureClassInitialized(InputEvent.class);
        }
        return AWTAccessor.inputEventAccessor;
    }
    
    public static void setMouseEventAccessor(AWTAccessor.MouseEventAccessor mouseEventAccessor) {
        AWTAccessor.mouseEventAccessor = mouseEventAccessor;
    }
    
    public static AWTAccessor.MouseEventAccessor getMouseEventAccessor() {
        if (AWTAccessor.mouseEventAccessor == null) {
            AWTAccessor.unsafe.ensureClassInitialized(MouseEvent.class);
        }
        return AWTAccessor.mouseEventAccessor;
    }
    
    public static void setFrameAccessor(AWTAccessor.FrameAccessor frameAccessor) {
        AWTAccessor.frameAccessor = frameAccessor;
    }
    
    public static AWTAccessor.FrameAccessor getFrameAccessor() {
        if (AWTAccessor.frameAccessor == null) {
            AWTAccessor.unsafe.ensureClassInitialized(Frame.class);
        }
        return AWTAccessor.frameAccessor;
    }
    
    public static void setKeyboardFocusManagerAccessor(AWTAccessor.KeyboardFocusManagerAccessor kfmAccessor) {
        AWTAccessor.kfmAccessor = kfmAccessor;
    }
    
    public static AWTAccessor.KeyboardFocusManagerAccessor getKeyboardFocusManagerAccessor() {
        if (AWTAccessor.kfmAccessor == null) {
            AWTAccessor.unsafe.ensureClassInitialized(KeyboardFocusManager.class);
        }
        return AWTAccessor.kfmAccessor;
    }
    
    public static void setMenuComponentAccessor(AWTAccessor.MenuComponentAccessor menuComponentAccessor) {
        AWTAccessor.menuComponentAccessor = menuComponentAccessor;
    }
    
    public static AWTAccessor.MenuComponentAccessor getMenuComponentAccessor() {
        if (AWTAccessor.menuComponentAccessor == null) {
            AWTAccessor.unsafe.ensureClassInitialized(MenuComponent.class);
        }
        return AWTAccessor.menuComponentAccessor;
    }
    
    public static void setEventQueueAccessor(AWTAccessor.EventQueueAccessor eventQueueAccessor) {
        AWTAccessor.eventQueueAccessor = eventQueueAccessor;
    }
    
    public static AWTAccessor.EventQueueAccessor getEventQueueAccessor() {
        if (AWTAccessor.eventQueueAccessor == null) {
            AWTAccessor.unsafe.ensureClassInitialized(EventQueue.class);
        }
        return AWTAccessor.eventQueueAccessor;
    }
    
    public static void setPopupMenuAccessor(AWTAccessor.PopupMenuAccessor popupMenuAccessor) {
        AWTAccessor.popupMenuAccessor = popupMenuAccessor;
    }
    
    public static AWTAccessor.PopupMenuAccessor getPopupMenuAccessor() {
        if (AWTAccessor.popupMenuAccessor == null) {
            AWTAccessor.unsafe.ensureClassInitialized(PopupMenu.class);
        }
        return AWTAccessor.popupMenuAccessor;
    }
    
    public static void setFileDialogAccessor(AWTAccessor.FileDialogAccessor fileDialogAccessor) {
        AWTAccessor.fileDialogAccessor = fileDialogAccessor;
    }
    
    public static AWTAccessor.FileDialogAccessor getFileDialogAccessor() {
        if (AWTAccessor.fileDialogAccessor == null) {
            AWTAccessor.unsafe.ensureClassInitialized(FileDialog.class);
        }
        return AWTAccessor.fileDialogAccessor;
    }
    
    public static void setScrollPaneAdjustableAccessor(AWTAccessor.ScrollPaneAdjustableAccessor scrollPaneAdjustableAccessor) {
        AWTAccessor.scrollPaneAdjustableAccessor = scrollPaneAdjustableAccessor;
    }
    
    public static AWTAccessor.ScrollPaneAdjustableAccessor getScrollPaneAdjustableAccessor() {
        if (AWTAccessor.scrollPaneAdjustableAccessor == null) {
            AWTAccessor.unsafe.ensureClassInitialized(ScrollPaneAdjustable.class);
        }
        return AWTAccessor.scrollPaneAdjustableAccessor;
    }
    
    public static void setCheckboxMenuItemAccessor(AWTAccessor.CheckboxMenuItemAccessor checkboxMenuItemAccessor) {
        AWTAccessor.checkboxMenuItemAccessor = checkboxMenuItemAccessor;
    }
    
    public static AWTAccessor.CheckboxMenuItemAccessor getCheckboxMenuItemAccessor() {
        if (AWTAccessor.checkboxMenuItemAccessor == null) {
            AWTAccessor.unsafe.ensureClassInitialized(AWTAccessor.CheckboxMenuItemAccessor.class);
        }
        return AWTAccessor.checkboxMenuItemAccessor;
    }
    
    public static void setCursorAccessor(AWTAccessor.CursorAccessor cursorAccessor) {
        AWTAccessor.cursorAccessor = cursorAccessor;
    }
    
    public static AWTAccessor.CursorAccessor getCursorAccessor() {
        if (AWTAccessor.cursorAccessor == null) {
            AWTAccessor.unsafe.ensureClassInitialized(AWTAccessor.CursorAccessor.class);
        }
        return AWTAccessor.cursorAccessor;
    }
    
    public static void setMenuBarAccessor(AWTAccessor.MenuBarAccessor menuBarAccessor) {
        AWTAccessor.menuBarAccessor = menuBarAccessor;
    }
    
    public static AWTAccessor.MenuBarAccessor getMenuBarAccessor() {
        if (AWTAccessor.menuBarAccessor == null) {
            AWTAccessor.unsafe.ensureClassInitialized(AWTAccessor.MenuBarAccessor.class);
        }
        return AWTAccessor.menuBarAccessor;
    }
    
    public static void setMenuItemAccessor(AWTAccessor.MenuItemAccessor menuItemAccessor) {
        AWTAccessor.menuItemAccessor = menuItemAccessor;
    }
    
    public static AWTAccessor.MenuItemAccessor getMenuItemAccessor() {
        if (AWTAccessor.menuItemAccessor == null) {
            AWTAccessor.unsafe.ensureClassInitialized(AWTAccessor.MenuItemAccessor.class);
        }
        return AWTAccessor.menuItemAccessor;
    }
    
    public static void setMenuAccessor(AWTAccessor.MenuAccessor menuAccessor) {
        AWTAccessor.menuAccessor = menuAccessor;
    }
    
    public static AWTAccessor.MenuAccessor getMenuAccessor() {
        if (AWTAccessor.menuAccessor == null) {
            AWTAccessor.unsafe.ensureClassInitialized(AWTAccessor.MenuAccessor.class);
        }
        return AWTAccessor.menuAccessor;
    }
    
    public static void setKeyEventAccessor(AWTAccessor.KeyEventAccessor keyEventAccessor) {
        AWTAccessor.keyEventAccessor = keyEventAccessor;
    }
    
    public static AWTAccessor.KeyEventAccessor getKeyEventAccessor() {
        if (AWTAccessor.keyEventAccessor == null) {
            AWTAccessor.unsafe.ensureClassInitialized(AWTAccessor.KeyEventAccessor.class);
        }
        return AWTAccessor.keyEventAccessor;
    }
    
    public static void setClientPropertyKeyAccessor(AWTAccessor.ClientPropertyKeyAccessor clientPropertyKeyAccessor) {
        AWTAccessor.clientPropertyKeyAccessor = clientPropertyKeyAccessor;
    }
    
    public static AWTAccessor.ClientPropertyKeyAccessor getClientPropertyKeyAccessor() {
        if (AWTAccessor.clientPropertyKeyAccessor == null) {
            AWTAccessor.unsafe.ensureClassInitialized(AWTAccessor.ClientPropertyKeyAccessor.class);
        }
        return AWTAccessor.clientPropertyKeyAccessor;
    }
    
    public static void setSystemTrayAccessor(AWTAccessor.SystemTrayAccessor systemTrayAccessor) {
        AWTAccessor.systemTrayAccessor = systemTrayAccessor;
    }
    
    public static AWTAccessor.SystemTrayAccessor getSystemTrayAccessor() {
        if (AWTAccessor.systemTrayAccessor == null) {
            AWTAccessor.unsafe.ensureClassInitialized(AWTAccessor.SystemTrayAccessor.class);
        }
        return AWTAccessor.systemTrayAccessor;
    }
    
    public static void setTrayIconAccessor(AWTAccessor.TrayIconAccessor trayIconAccessor) {
        AWTAccessor.trayIconAccessor = trayIconAccessor;
    }
    
    public static AWTAccessor.TrayIconAccessor getTrayIconAccessor() {
        if (AWTAccessor.trayIconAccessor == null) {
            AWTAccessor.unsafe.ensureClassInitialized(AWTAccessor.TrayIconAccessor.class);
        }
        return AWTAccessor.trayIconAccessor;
    }
    
    public static void setDefaultKeyboardFocusManagerAccessor(AWTAccessor.DefaultKeyboardFocusManagerAccessor defaultKeyboardFocusManagerAccessor) {
        AWTAccessor.defaultKeyboardFocusManagerAccessor = defaultKeyboardFocusManagerAccessor;
    }
    
    public static AWTAccessor.DefaultKeyboardFocusManagerAccessor getDefaultKeyboardFocusManagerAccessor() {
        if (AWTAccessor.defaultKeyboardFocusManagerAccessor == null) {
            AWTAccessor.unsafe.ensureClassInitialized(AWTAccessor.DefaultKeyboardFocusManagerAccessor.class);
        }
        return AWTAccessor.defaultKeyboardFocusManagerAccessor;
    }
    
    public static void setSequencedEventAccessor(AWTAccessor.SequencedEventAccessor sequencedEventAccessor) {
        AWTAccessor.sequencedEventAccessor = sequencedEventAccessor;
    }
    
    public static AWTAccessor.SequencedEventAccessor getSequencedEventAccessor() {
        return AWTAccessor.sequencedEventAccessor;
    }
    
    public static void setToolkitAccessor(AWTAccessor.ToolkitAccessor toolkitAccessor) {
        AWTAccessor.toolkitAccessor = toolkitAccessor;
    }
    
    public static AWTAccessor.ToolkitAccessor getToolkitAccessor() {
        if (AWTAccessor.toolkitAccessor == null) {
            AWTAccessor.unsafe.ensureClassInitialized(Toolkit.class);
        }
        return AWTAccessor.toolkitAccessor;
    }
    
    public static void setInvocationEventAccessor(AWTAccessor.InvocationEventAccessor invocationEventAccessor) {
        AWTAccessor.invocationEventAccessor = invocationEventAccessor;
    }
    
    public static AWTAccessor.InvocationEventAccessor getInvocationEventAccessor() {
        return AWTAccessor.invocationEventAccessor;
    }
    
    public static AWTAccessor.SystemColorAccessor getSystemColorAccessor() {
        if (AWTAccessor.systemColorAccessor == null) {
            AWTAccessor.unsafe.ensureClassInitialized(SystemColor.class);
        }
        return AWTAccessor.systemColorAccessor;
    }
    
    public static void setSystemColorAccessor(AWTAccessor.SystemColorAccessor systemColorAccessor) {
        AWTAccessor.systemColorAccessor = systemColorAccessor;
    }
    
    public static AWTAccessor.AccessibleContextAccessor getAccessibleContextAccessor() {
        if (AWTAccessor.accessibleContextAccessor == null) {
            AWTAccessor.unsafe.ensureClassInitialized(AccessibleContext.class);
        }
        return AWTAccessor.accessibleContextAccessor;
    }
    
    public static void setAccessibleContextAccessor(AWTAccessor.AccessibleContextAccessor accessibleContextAccessor) {
        AWTAccessor.accessibleContextAccessor = accessibleContextAccessor;
    }
    
    static {
        unsafe = Unsafe.getUnsafe();
    }
    
    public interface AWTEventAccessor
    {
        public abstract void setPosted(AWTEvent p0);
        
        public abstract void setSystemGenerated(AWTEvent p0);
        
        public abstract boolean isSystemGenerated(AWTEvent p0);
        
        public abstract AccessControlContext getAccessControlContext(AWTEvent p0);
        
        public abstract byte[] getBData(AWTEvent p0);
        
        public abstract void setBData(AWTEvent p0, byte[] p1);
    }
    
    public interface AccessibleContextAccessor
    {
        public abstract void setAppContext(AccessibleContext p0, AppContext p1);
        
        public abstract AppContext getAppContext(AccessibleContext p0);
    }
    
    public interface CheckboxMenuItemAccessor
    {
        public abstract boolean getState(CheckboxMenuItem p0);
    }
    
    public interface ClientPropertyKeyAccessor
    {
        public abstract Object getJComponent_TRANSFER_HANDLER();
    }
    
    public interface ComponentAccessor
    {
        public abstract void setBackgroundEraseDisabled(Component p0, boolean p1);
        
        public abstract boolean getBackgroundEraseDisabled(Component p0);
        
        public abstract Rectangle getBounds(Component p0);
        
        public abstract void setMixingCutoutShape(Component p0, Shape p1);
        
        public abstract void setGraphicsConfiguration(Component p0, GraphicsConfiguration p1);
        
        public abstract boolean requestFocus(Component p0, CausedFocusEvent.Cause p1);
        
        public abstract boolean canBeFocusOwner(Component p0);
        
        public abstract boolean isVisible(Component p0);
        
        public abstract void setRequestFocusController(RequestFocusController p0);
        
        public abstract AppContext getAppContext(Component p0);
        
        public abstract void setAppContext(Component p0, AppContext p1);
        
        public abstract Container getParent(Component p0);
        
        public abstract void setParent(Component p0, Container p1);
        
        public abstract void setSize(Component p0, int p1, int p2);
        
        public abstract Point getLocation(Component p0);
        
        public abstract void setLocation(Component p0, int p1, int p2);
        
        public abstract boolean isEnabled(Component p0);
        
        public abstract boolean isDisplayable(Component p0);
        
        public abstract Cursor getCursor(Component p0);
        
        public abstract ComponentPeer getPeer(Component p0);
        
        public abstract void setPeer(Component p0, ComponentPeer p1);
        
        public abstract boolean isLightweight(Component p0);
        
        public abstract boolean getIgnoreRepaint(Component p0);
        
        public abstract int getWidth(Component p0);
        
        public abstract int getHeight(Component p0);
        
        public abstract int getX(Component p0);
        
        public abstract int getY(Component p0);
        
        public abstract Color getForeground(Component p0);
        
        public abstract Color getBackground(Component p0);
        
        public abstract void setBackground(Component p0, Color p1);
        
        public abstract Font getFont(Component p0);
        
        public abstract void processEvent(Component p0, AWTEvent p1);
        
        public abstract AccessControlContext getAccessControlContext(Component p0);
        
        public abstract void revalidateSynchronously(Component p0);
    }
    
    public interface ContainerAccessor
    {
        public abstract void validateUnconditionally(Container p0);
        
        public abstract Component findComponentAt(Container p0, int p1, int p2, boolean p3);
    }
    
    public interface CursorAccessor
    {
        public abstract long getPData(Cursor p0);
        
        public abstract void setPData(Cursor p0, long p1);
        
        public abstract int getType(Cursor p0);
    }
    
    public interface DefaultKeyboardFocusManagerAccessor
    {
        public abstract void consumeNextKeyTyped(DefaultKeyboardFocusManager p0, KeyEvent p1);
    }
    
    public interface EventQueueAccessor
    {
        public abstract Thread getDispatchThread(EventQueue p0);
        
        public abstract boolean isDispatchThreadImpl(EventQueue p0);
        
        public abstract void removeSourceEvents(EventQueue p0, Object p1, boolean p2);
        
        public abstract boolean noEvents(EventQueue p0);
        
        public abstract void wakeup(EventQueue p0, boolean p1);
        
        public abstract void invokeAndWait(Object p0, Runnable p1) throws InterruptedException, InvocationTargetException;
        
        public abstract void setFwDispatcher(EventQueue p0, FwDispatcher p1);
        
        public abstract long getMostRecentEventTime(EventQueue p0);
    }
    
    public interface FileDialogAccessor
    {
        public abstract void setFiles(FileDialog p0, File[] p1);
        
        public abstract void setFile(FileDialog p0, String p1);
        
        public abstract void setDirectory(FileDialog p0, String p1);
        
        public abstract boolean isMultipleMode(FileDialog p0);
    }
    
    public interface FrameAccessor
    {
        public abstract void setExtendedState(Frame p0, int p1);
        
        public abstract int getExtendedState(Frame p0);
        
        public abstract Rectangle getMaximizedBounds(Frame p0);
    }
    
    public interface InputEventAccessor
    {
        public abstract int[] getButtonDownMasks();
    }
    
    public interface InvocationEventAccessor
    {
        public abstract void dispose(InvocationEvent p0);
    }
    
    public interface KeyEventAccessor
    {
        public abstract void setRawCode(KeyEvent p0, long p1);
        
        public abstract void setPrimaryLevelUnicode(KeyEvent p0, long p1);
        
        public abstract void setExtendedKeyCode(KeyEvent p0, long p1);
        
        public abstract Component getOriginalSource(KeyEvent p0);
    }
    
    public interface KeyboardFocusManagerAccessor
    {
        public abstract int shouldNativelyFocusHeavyweight(Component p0, Component p1, boolean p2, boolean p3, long p4, CausedFocusEvent.Cause p5);
        
        public abstract boolean processSynchronousLightweightTransfer(Component p0, Component p1, boolean p2, boolean p3, long p4);
        
        public abstract void removeLastFocusRequest(Component p0);
        
        public abstract void setMostRecentFocusOwner(Window p0, Component p1);
        
        public abstract KeyboardFocusManager getCurrentKeyboardFocusManager(AppContext p0);
        
        public abstract Container getCurrentFocusCycleRoot();
    }
    
    public interface MenuAccessor
    {
        public abstract Vector getItems(Menu p0);
    }
    
    public interface MenuBarAccessor
    {
        public abstract Menu getHelpMenu(MenuBar p0);
        
        public abstract Vector getMenus(MenuBar p0);
    }
    
    public interface MenuComponentAccessor
    {
        public abstract AppContext getAppContext(MenuComponent p0);
        
        public abstract void setAppContext(MenuComponent p0, AppContext p1);
        
        public abstract MenuContainer getParent(MenuComponent p0);
        
        public abstract Font getFont_NoClientCode(MenuComponent p0);
        
        public abstract <T extends MenuComponentPeer> T getPeer(MenuComponent p0);
    }
    
    public interface MenuItemAccessor
    {
        public abstract boolean isEnabled(MenuItem p0);
        
        public abstract String getActionCommandImpl(MenuItem p0);
        
        public abstract boolean isItemEnabled(MenuItem p0);
        
        public abstract String getLabel(MenuItem p0);
        
        public abstract MenuShortcut getShortcut(MenuItem p0);
    }
    
    public interface MouseEventAccessor
    {
        public abstract boolean isCausedByTouchEvent(MouseEvent p0);
        
        public abstract void setCausedByTouchEvent(MouseEvent p0, boolean p1);
    }
    
    public interface PopupMenuAccessor
    {
        public abstract boolean isTrayIconPopup(PopupMenu p0);
    }
    
    public interface ScrollPaneAdjustableAccessor
    {
        public abstract void setTypedValue(ScrollPaneAdjustable p0, int p1, int p2);
    }
    
    public interface SequencedEventAccessor
    {
        public abstract AWTEvent getNested(AWTEvent p0);
        
        public abstract boolean isSequencedEvent(AWTEvent p0);
    }
    
    public interface SystemColorAccessor
    {
        public abstract void updateSystemColors();
    }
    
    public interface SystemTrayAccessor
    {
        public abstract void firePropertyChange(SystemTray p0, String p1, Object p2, Object p3);
    }
    
    public interface ToolkitAccessor
    {
        public abstract void setPlatformResources(ResourceBundle p0);
    }
    
    public interface TrayIconAccessor
    {
        public abstract void addNotify(TrayIcon p0) throws AWTException;
        
        public abstract void removeNotify(TrayIcon p0);
    }
    
    public interface WindowAccessor
    {
        public abstract float getOpacity(Window p0);
        
        public abstract void setOpacity(Window p0, float p1);
        
        public abstract Shape getShape(Window p0);
        
        public abstract void setShape(Window p0, Shape p1);
        
        public abstract void setOpaque(Window p0, boolean p1);
        
        public abstract void updateWindow(Window p0);
        
        public abstract Dimension getSecurityWarningSize(Window p0);
        
        public abstract void setSecurityWarningSize(Window p0, int p1, int p2);
        
        public abstract void setSecurityWarningPosition(Window p0, Point2D p1, float p2, float p3);
        
        public abstract Point2D calculateSecurityWarningPosition(Window p0, double p1, double p2, double p3, double p4);
        
        public abstract void setLWRequestStatus(Window p0, boolean p1);
        
        public abstract boolean isAutoRequestFocus(Window p0);
        
        public abstract boolean isTrayIconWindow(Window p0);
        
        public abstract void setTrayIconWindow(Window p0, boolean p1);
        
        public abstract Window[] getOwnedWindows(Window p0);
    }
    
    public interface DragSourceContextAccessor
    {
        public abstract DragSourceContextPeer getPeer(DragSourceContext p0);
    }
}
